.aws-cli:
  image:
    entrypoint: [""]
    name: amazon/aws-cli

.terraform:
  image: registry.gitlab.com/gitlab-org/terraform-images/stable:latest

variables:
  TF_STATE_NAME: $DEPLOY_ENV-state
  TF_VAR_DEPLOY_ENV: $DEPLOY_ENV

stages:
  - build
  - deploy


aws-creds:
  stage: build
  extends: .aws-cli
  script:
    - STS=($(aws sts assume-role-with-web-identity
      --role-arn $ROLE_ARN
      --role-session-name "GitLab-${CI_PROJECT_ID}-${CI_PIPELINE_ID}"
      --web-identity-token $CI_JOB_JWT_V2
      --duration-seconds ${STS_TOKEN_DURATION:-900}
      --query 'Credentials.[AccessKeyId,SecretAccessKey,SessionToken]'
      --output text))
    - echo "AWS_ACCESS_KEY_ID=${STS[0]}" >> aws-creds.env
    - echo "AWS_SECRET_ACCESS_KEY=${STS[1]}" >> aws-creds.env
    - echo "AWS_SESSION_TOKEN=${STS[2]}" >> aws-creds.env
  artifacts:
    reports:
      dotenv: aws-creds.env
  tags:
    - gitlab-org

validate:
  stage: build
  extends: .terraform
  script: gitlab-terraform validate
  tags:
    - gitlab-org    

plan:
  stage: build
  extends: .terraform
  needs:
    - aws-creds
  script: gitlab-terraform plan
  artifacts:
    paths:
      - ./plan.cache
  tags:
    - gitlab-org




